import java.awt.*;
import java.applet.*;
public class atomTest
{
    /*________________________________
    ___________Variable_____________*/
    pigFunc pig;
    vectorFunc v;
    collisionFunc coll = new collisionFunc();
    atomFunc a = new atomFunc();
    
    atom[] atomLst = new atom[20];
    vector boxPos = new vector(500,70),
           boxSize = new vector(340,170),
           gravity = new vector(0,0.05),
           l1 = new vector(850,200),
           l2 = new vector(700,240),
           circleCenter = new vector( 600,170);
    float circleRadius = 50;
    
    float deltaT = 0.1f;

    /*________________________________
    ___________Initialisation_______*/
    public void initialize() 
    {
        pig = new pigFunc();
        v = new vectorFunc();
        //System.out.println("vector d: " + d.x + "," + d.y);

        for (int i=0;i<20;i++)
        {
            atomLst[i] = new atom(520+i*15, 80, 2, 4);
        }
    }
    /*________________________________
    ___________Main Loop____________*/
    public void loop()
    {
        for (float t=0;t<1.0f;t+=deltaT)
            for (int i=0;i<20;i++)
            {
                vector dest = v.add(atomLst[i].pos, v.scale(atomLst[i].vel,deltaT));
                if (coll.circleInBox(dest, atomLst[i].radius, boxPos, boxSize) == false ||
                    coll.circleCircle(dest, atomLst[i].radius, circleCenter, circleRadius) == true ||
                    coll.lineLine(atomLst[i].pos, dest, l1, l2) == true)
                {
                    atomLst[i] = a.stop(atomLst[i]);
                }
                else
                {
                    atomLst[i] = a.move(atomLst[i],deltaT);
                }
                atomLst[i] = a.accel(atomLst[i],gravity,deltaT);
            }


    }
    
    /*________________________________
    ___________draw_________________*/
    public void paint (Graphics g) 
    {
        //draw something
        g.setColor(Color.black);
        g.drawLine(400,60,500,60);
        g.drawString("atom Test",502,64);

        g.setColor(Color.red);
        for (int i=0; i<20; i++)
        {
            pig.circle(g, atomLst[i].pos,atomLst[i].radius);
        }
        
        g.setColor(Color.blue);
        pig.rect(g, boxPos, boxSize);

        pig.circle(g, circleCenter, circleRadius);

        pig.line(g,l1,l2);
    }
}
