import java.awt.*;
import java.applet.*;
public class atomTest2
{
    /*________________________________
    ___________Variable_____________*/
    pigFunc pig;
    vectorFunc v;
    collisionFunc coll = new collisionFunc();
    atomFunc a = new atomFunc();
    
    atom[] atomLst = new atom[25];
    vector boxPos = new vector(500,300),
           boxSize = new vector(340,200),
           gravity = new vector(0,0.05);

    float deltaT = 0.1f;

    /*________________________________
    ___________Initialisation_______*/
    public void initialize() 
    {
        pig = new pigFunc();
        v = new vectorFunc();
        //System.out.println("vector d: " + d.x + "," + d.y);

        for (int i=0;i<20;i++)
        {
            atomLst[i] = new atom(520+i*15, 320, 2, 4);
        }
        atomLst[20] = new atom(600,400,4,20);
        atomLst[21] = new atom(680,400,4,20);
        atomLst[22] = new atom(760,400,4,20);
        atomLst[23] = new atom(560,440,20,30);
        //atomLst[23] = new atom(600,400,4,20);
    }
    /*________________________________
    ___________Main Loop____________*/
    public void loop()
    {
        for (float t=0;t<1;t+=deltaT)
            for (int i=0;i<24;i++)
            {
                vector dest = v.add(atomLst[i].pos, v.scale(atomLst[i].vel,deltaT));
                if (coll.circleInBox(dest, atomLst[i].radius, boxPos, boxSize) == false)
                {
                    atomLst[i] = a.stop(atomLst[i]);
                }
                else
                {
                    for (int j=0;j<24;j++)
                    {
                        if (i != j && coll.circleCircle(dest,atomLst[i].radius, atomLst[j].pos, atomLst[j].radius))
                        {
                            vector force = a.invforce(atomLst[i]);
                            atomLst[i] = a.stop(atomLst[i]);
                            a.force(atomLst[j],force,deltaT);
                        }
                    }
                    atomLst[i] = a.move(atomLst[i],deltaT);
                }
                atomLst[i] = a.accel(atomLst[i],gravity,deltaT);
            }


    }
    
    /*________________________________
    ___________draw_________________*/
    public void paint (Graphics g) 
    {
        //draw something
        g.setColor(Color.black);
        g.drawLine(400,60,500,60);
        g.drawString("atom Test",502,64);

        g.setColor(Color.red);
        for (int i=0; i<24; i++)
        {
            pig.circle(g, atomLst[i].pos,atomLst[i].radius);
        }
        
        g.setColor(Color.blue);
        pig.rect(g, boxPos, boxSize);

    }
}
