import static java.lang.Math.*;

public class collisionFunc{
    static vectorFunc v;
    
    public collisionFunc()
    {
        v = new vectorFunc();
    }
    
    public static Boolean lineLine(vector p1, vector p2, vector p3, vector p4)
    {
        float pZero = v.parallelZero(p1,p2,p3,p4);
        if (pZero == 0)
            return false;
        float Ua = v.intersectUa(p1,p2,p3,p4,pZero);
        if (Ua < 0 || Ua > 1)
            return false;
        float Ub = v.intersectUb(p1,p2,p3,p4,pZero);
        if (Ub < 0 || Ub > 1)
            return false;
        return true;
    }
    
    public static Boolean pointBox(vector pos, vector boxPos, vector boxSize)
    {
        return (pos.x > boxPos.x) && 
               (pos.y > boxPos.y) && 
               (pos.x < boxPos.x + boxSize.x) &&
               (pos.y < boxPos.y + boxSize.y);
    }
    
    public static Boolean pointCircle(vector pos, vector center, float radius)
    {
        return v.magSQ(v.sub(center,pos)) < pow(radius,2);
    }
    
    public static Boolean circleCircle(vector centerA, float radiusA, vector centerB, float radiusB)
    {
        return v.magSQ(v.sub(centerB,centerA)) < pow(radiusA+radiusB,2);
    }
    
    public static Boolean circleInBox(vector center, float radius, vector boxPos, vector boxSize)
    {
        return center.x - radius > boxPos.x &&
               center.y - radius > boxPos.y &&
               center.x + radius < boxPos.x + boxSize.x &&
               center.y + radius < boxPos.y + boxSize.y;
    }
};
